#include "bits/stdc++.h"
using namespace std;

#define int long long
#define fi first
#define se second

const int MAXN = 80'000 + 100;
const int INF = 1000'000'000'000'000'000;


void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> x(m);
    for (int i = 0; i < m; i++) {
        cin >> x[i];
    }
    vector<pair<int, int>> dp(2 * MAXN, {INF, -INF});
    int nl = MAXN;
    dp[nl] = {0, 0};
    vector<pair<int, int>> new_dp1;
    vector<pair<int, int>> new_dp2;
    for (int i = 0; i < m; i++) {
        new_dp1.assign(2 * MAXN, {INF, -INF});
        new_dp2.assign(2 * MAXN, {INF, -INF});
        for (int j = 0; j < 2 * MAXN; j++) {
            if (x[i] - j + 2 * nl < 0 || x[i] - j + 2 * nl >= 2 * MAXN)
                continue;
            new_dp1[x[i] - j + 2 * nl].fi = min(dp[j].fi, new_dp1[x[i] - j + 2 * nl].fi);
            new_dp1[x[i] - j + 2 * nl].se = max(dp[j].se, new_dp1[x[i] - j + 2 * nl].se);
        }
        for (int j = 0; j < 2 * MAXN; j++) {
            new_dp2[j].fi = min(x[i] - dp[j].se, new_dp2[j].fi);
            new_dp2[j].se = max(x[i] - dp[j].fi, new_dp2[j].se);
        }
        for (int j = 0; j < 2 * MAXN; j++) {
            dp[j].fi = min(new_dp1[j].fi, new_dp2[j].fi);
            dp[j].se = max(new_dp1[j].se, new_dp2[j].se);
        }
    }
    int res = -INF;
    for (int j = 0; j < 2 * MAXN; j++) {
        res = max(res, j - nl + dp[j].se);
    }
    cout << res << '\n';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int T = 1;
    cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}
