#include <bits/stdc++.h>
using namespace std;

#define int long long
#define fi first
#define se second

const int INF = 1000'000'000'000'000'000;

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> x(m);
    for (int i = 0; i < m; i++) {
        cin >> x[i];
    }
    vector<vector<int>> dp(m + 1, vector<int> (n + 1, -INF));
    dp[m][0] = 0;
    for (int i = m - 1; i >= 0; i--) {
        for (int j = 0; j < n; j++) {
            dp[i][j] = dp[i + 1][j + 1] - x[i];
        }
        for (int j = 1; j <= n; j++) {
            dp[i][j] = max(dp[i][j], dp[i + 1][j - 1] + x[i]);
        }
    }
    int res = -INF;
    for (int i = 0; i <= n; i++) {
        res = max(res, dp[0][i]);
    }
    cout << res << '\n';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int T = 1;
    cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}
