#include <bits/stdc++.h>
using namespace std;

#define int long long
#define fi first
#define se second

const int INF = 1000'000'000'000'000'000;

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> x(m);
    for (int i = 0; i < m; i++) {
        cin >> x[i];
    }
    vector<int> ans(m);
    for (int i = m - 1; i >= 0; i--) {
        int b = 0, k = m;
        for (int j = m - 1; j > i; j--) {
            if (ans[j] == 1)
                b++;
            else
                b--;
            if (b <= 1)
                k = j - 1;
        }
        if (b < n) {
            ans[i] = 1;
            continue;
        }
        int pos = -1;
        for (int j = k; j > i; j--) {
            if (ans[j] == 0)
                continue;
            if (pos == -1)
                pos = j;
            else if (x[j] < x[pos])
                pos = j;
        }
        if (pos != -1 && x[pos] < x[i]) {
            ans[pos] = 0;
            ans[i] = 1;
        }
    }
    int res = 0;
    for (int j = m - 1; j >= 0; j--) {
        if (ans[j] == 1) {
            res += x[j];
        } else {
            res -= x[j];
        }
    }
    cout << res << '\n';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int T = 1;
    cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}
